$ PAGEWIDTH(78)
;              Program APRSTRAK med 89C4051 print H03013
;              Xtal frq = 11.0592 MHz  == 1  MC = 1.085 uS
;
;Copyright: (c)2004, OZ4HZ,Hans Boje Jensen (oz4hz@get2net.dk).
;         All rights reserved.
;         This software is available for non-commercial amateur radio
;  	  or educational applications.  All other uses are prohibited.
;	  This software may be modified if the resulting code are
;         made available publicly and the original author given credit.
;
; 
; 060311  software for carrier detect.
; 060317  to minimize current consumption P1 are set high after transmission. 
;         corrected minor bug at fixpos(ition) 
;
$ NOMOD51
$ INCLUDE(reg2051.INC)
;
;
; SFR notations
;
;
;       Specielle opstninger
;
RB2      EQU 010H              ; reg bank 2

CR       EQU 00DH              ; carriage return
LF       EQU 00AH              ; linefeed
BAUD     EQU 0F4H              ; baudrate 4800
EEPROM   EQU 0A0H              ; EEPROM I2C adr
;
; data i eeprom
;
; setup 1
;
EFlag1_1 EQU 000H              ;
ET_hi1   EQU 001H              ; tid mellem uds hi
ET_lo1   EQU 002H              ; tid mellem uds lo

ESTim1   EQU 003H              ; Slow rate time = ESTim*5sec+ Fastrate
EFvel1   EQU 004H              ; Fast speed
ESvel1   EQU 005H              ; slow speed
ETurnA1  EQU 006H              ; Min turn angle
ETurnS1  EQU 007H              ; turn slope
ETurnT1  EQU 008H              ; min turn time

EBeaS1   EQU 009H              ; start adr p status beacon text
ECalAn1  EQU 00AH              ; antal bytes i call+
EBeaAn1  EQU 00BH              ; antal byte i beacon tekst    ?
EBrate1  EQU 00CH              ; beacon rate
ESYMID1  EQU 00DH              ;
ESYMTAB1 EQU 00EH              ;
ETXDEL1  EQU 00FH              ; antal flags ved txstart
ECaSD1   EQU 010H              ; startadr for data1
;
; setup 2
EFlag1_2 EQU 080H              ;
ET_hi2   EQU 081H              ; tid mellem uds hi
ET_lo2   EQU 082H              ; tid mellem uds lo

ESTim2   EQU 083H              ; Slow rate time = ESTim* Fastrate
EFvel2   EQU 084H              ; Fast speed
ESvel2   EQU 085H              ; slow speed
ETurnA2  EQU 086H              ; Min turn angle
ETurnS2  EQU 087H              ; turn slope
ETurnT2  EQU 088H              ; min turn time
;
EBeaS2   EQU 089H              ; start adr p beacon text
ECalAn2  EQU 08AH              ; antal bytes i call+
EBeaAn2  EQU 08BH              ; antal byte i beacon tekst
EBrate2  EQU 08CH              ; beacon rate
ESYMID2  EQU 08DH              ; 
ESYMTAB2 EQU 08EH              ;
ETXDEL2  EQU 08FH              ; number of flags at txstart
ECaSD2   EQU 090H              ; startadr for data2

EFixPos  EQU 0EEH              ; fixed position total 18 bytes
;                                from 0EEH to 0FFH
;
T1200    EQU 0C0H              ; 1200 Hz timer (TL0)
T2200    EQU 0DDH              ; 2200 Hz timer (TL0)
;
;        Port 1
;
;        BIT P1.0              ; not used
;        BIT P1.1              ; not used
S1       BIT P1.2              ; S1 switch for pri/sec config
TAST     BIT P1.3              ; TX PTT
;        BIT P1.4              ; tone output
;        BIT P1.5              ; tone output
;        BIT P1.6              ; tone output
;        BIT P1.7              ; tone output
;
;        Port 3
;
;RXD     BIT P3.0              ; RS232 RX
;TXD     BIT P3.1              ; RS232 TX
GPSON    BIT P3.2              ; power to GPS unit (ON = 0 OFF = 1)
LEDred   BIT P3.3              ; red LED
SCL      BIT P3.4              ; I2C clk
SDA      BIT P3.5              ; I2C data
RXAF     BIT P3.6              ; used for RX audio
LEDgreen BIT P3.7              ; green LED
;
;
; Intern RAM
;
; RB0    Data 000H - 007H
;
SinVal   DATA 000H             ; (1)   table for sinusvalues
T_BUF    EQU SinVal            ; bruges ogs til GPS data for GS, TT og alt
;        DATA 001H             ;  2
;        DATA 002H             ;  3
ALTBUF   DATA 003H             ;  4
;        DATA 004H             ;  5
;        DATA 005H             ;  6
;        DATA 006H             ;  7
;        DATA 007H             ;  8
;        DATA 008H             ;  9
;        DATA 009H             ; 10
S5Count  DATA 00AH             ; 11
SCount   DATA 00BH             ; 12 also used as counter in smartbeacon mode
BCDBUF1  DATA 00CH             ; 13
BCDBUF2  DATA 00DH             ; 14
RMCCou   DATA 00EH             ; 15 counter for RMC (navdata)
TurnA    DATA 00FH             ; 16 turn angle (/2)
;
; RB2    Data 010H - 017H  used as working reg
;
CrcL     DATA 018H             ; crc hi / ventetids timer (hi)
T_lo     EQU CrcL              ;
CrcH     DATA 019H             ; crc lo / ventetids timer (lo)
T_hi     EQU CrcH              ;
CoOne    DATA 01AH             ; tller for '1' (bruges i TX del)
TThr     EQU CoOne             ; Turn threshold
Creg     DATA 01BH             ; temp reg (bruges i RS interrupt og I2C)
B_rate   DATA 01CH             ; beaconrate
BytAdr   DATA 01DH             ; adr p  bytes i int RAM
CaAnt    DATA 01EH             ;
TCount   EQU CaAnt             ; counter in smartbeaconmode
BeAnt    DATA 01FH             ;
;
; Flag reg
;
Freg1    DATA 020H             ; flags
Freg2    DATA 021H             ; flags
;
TBaud    BIT Freg1.0           ; flag for baudrate timeout
;        BIT Freg1.1           ;
GPSOK    BIT Freg1.2           ; received GPS data
AltOK    BIT Freg1.3           ; altitude  OK
NoAck    BIT Freg1.4           ; I2C no Ack
WaitTime BIT Freg1.5           ; wait
TXBeaC   BIT Freg1.6           ; send beacon text
RMCOK    BIT Freg1.7           ; RMC data OK
;
GPSPWR   BIT Freg2.0           ; GPS power off between transmissions
ShowALT  BIT Freg2.1           ; show altitude
SMARTB   BIT Freg2.2           ; smartbeaconing
FixPos   BIT Freg2.3           ; fixed position - get pos from eepro
;        BIT Freg2.4           ;
CPeg     BIT Freg2.5           ; Turning Angle  > turning Threshold
WaitSB   BIT Freg2.6           ; Wait in Smart Beacon mode
OPS1     BIT Freg2.7           ; flag for configuration 1 or 2
;
GSBin    DATA 022H             ; GS (Groundspeed) in binary
THBin    DATA 023H             ; TH (True Heading) in binary

BUF1     DATA 024H             ; data buffer start
BUF2     DATA BUF1+1           ;
BUF_TH   DATA BUF1+21          ; end of TH data 
BUF_GS   DATA BUF1+25          ; end of GS data
BUFALT   DATA BUF1+27          ; altitude start
BUFALTE  DATA BUF1+34          ; altitude end
;
SPstart  EQU 05FH              ; SP Start i 060H
;
         ORG 0000H
         AJMP START            ;
;
; timer0 interrupt for tone 1200 / 2200 Hz
;
         ORG 000BH             ; R0 used as counter and pointer
Tim0Int: DJNZ R0,NxtSin        ; 2 MC
         MOV P1,@R0            ; 2 MC
         MOV R0,#12            ; 1 MC
         RETI                  ; 2 MC
NxtSin:  MOV P1,@R0            ; 2 MC
Retii:   RETI                  ; 2 MC
;
;  timer 1 interrupts for 1200 baud
;
         ORG 001BH             ; timer1 int
         AJMP Tim1Int          ;
;
         ORG 0023H             ; RS232 interrupts
         AJMP RSINT            ;
;
         ORG 0030H             ;
;
START:   MOV P1,#0F7H          ; no PTT
         MOV P3,#077H          ; no GPS pwr , Green+red LED on
         MOV PSW,#RB2          ;
         MOV TMOD,#021H        ; timer mode T0 16 bit counter
                               ; T1 8 bit reload ( RS232 )
         MOV SP,#SPstart       ;
         MOV PCON,#080H        ; power control SMOD = 1
         MOV SCON,#050H        ; 8 bit Uart, enable RX(RS232)
         MOV TL1,#BAUD         ; timer1 used for RS232
         MOV TH1,#BAUD         ;
         MOV TCON,#0C1H        ; start timer1, INT0 edge trig
         CLR EA                ;
         MOV Freg1,#0          ;
         MOV Freg2,#0          ;
         MOV C,S1              ; read S1 (config switch)
         MOV OPS1,C            ; S1 = 1 use primary config
         ACALL GetBeaRate      ;
         MOV A,#EFlag1_1       ;
         JB OPS1,OpSet2        ;
         MOV A,#EFlag1_2       ;
OpSet2:  ACALL SetEEP          ;
         ACALL ReEEP           ;
         ANL A,#01FH           ;
         MOV C,OPS1            ; config 1 or 2
         MOV ACC.7,C           ;
         MOV Freg2,A           ; move flag to Freg2
         ACALL VerTxtOut       ;
         CLR GPSon             ; pwr on GPS
         MOV R1,#2             ;
FlashL:  CLR LEDgreen          ;
         CALL MaxDel           ;
         CALL MaxDel           ;
         CALL MaxDel           ;
         SETB LEDgreen         ;
         CLR LEDred            ;
         CALL MaxDel           ;
         CALL MaxDel           ;
         CALL MaxDel           ;
         SETB LEDred           ; red LED off
         DJNZ R1,FlashL        ;
         SETB LEDgreen         ; green LED off
         CALL MaxDel           ;
         JNB OPS1,LRed         ;
         CLR LEDgreen          ; config1 Green LED on
         SJMP LDel             ;
LRed:    CLR LEDred            ; config2 Red LED on
LDel:    MOV R0,#10            ;
LEDDel:  CALL MaxDel           ;
         DJNZ R0,LEDDel        ;
         SETB LEDgreen         ; green LED off
         SETB LEDred           ; red LED off
         JB FixPos,FStart      ; If FixPos then a startup delay is needed
         AJMP Loop             ;
;
;  fixed position only
;
FStart:  MOV SP,#SPstart       ; 
         ACALL Retii           ;
         MOV IE,#090H          ; only interrupts from RS232
         MOV R0,#0             ;
DelR0:   MOV R1,#0             ; delay loop at startup
DelR1:   MOV R2,#0             ; approx 36 sec
         DJNZ R2,$             ; to read/write config settings
         DJNZ R1,DelR1         ;
         DJNZ R0,DelR0         ;

FixTX:   ACALL GetFixD         ; get position data from eeprom
TXnow:   CLR EA                ; GPS data valid
         ACALL SendPacket      ;
         CLR EA                ;
         ACALL Retii           ;
         MOV TCount,#0         ; 

NoSmart: MOV A,TCount          ;
         JZ ReadFT             ;
         MOV T_hi,#0           ;
         MOV T_lo,#100         ;
         SJMP TimOK            ;
ReadFT:  MOV A,#ET_hi1         ;
         JB OPS1,SetHi1        ;
         MOV A,#ET_hi2         ;
SetHi1:  ACALL SetEEP          ;
         ACALL ReEEP           ;
         MOV T_hi,A            ;
         ACALL ReEEP           ;
         MOV T_lo,A            ;
TimOK:   MOV S5Count,#0        ;
         SETB WaitTime         ;

Nx5Sec:  MOV TMOD,#012H        ; 8 bit counter T0  16 bit counter 1
         MOV SCON,#0           ;
         MOV TL1,#0EDH         ; timer 1 (47mS)
         MOV TH1,#053H         ;
         SETB TR1              ;
         SETB WaitSB           ;
         CLR CPeg              ;
         MOV SCount,#100       ;
         JB FixPos,WaitInt     ; jump if fixed position
         JNB RMCOK,WaitInt     ; jump if no valid GPS data
         JNB GPSPWR,WaitInt    ; jump when cont PWR on GPS unit
         SETB GPSON            ; GPS power off
WaitInt: MOV IE,#088H          ; enable interrups from timer1
WaitTim: JNB WaitSB,TryGPS     ; wait for Smartbeacon timeout
         MOV C,RXAF            ;
         MOV LEDgreen,C        ;
         JB WaitTime,WaitTim   ; or normal timeout
TryGPS:  SETB LEDgreen         ;
         CLR EA                ;
         MOV TMOD,#021H        ; timer mode T0 16 bit counter
                               ; T1 8 bit reload ( RS232 )
         MOV PCON,#080H        ;
         MOV SCON,#050H        ;
         MOV TL1,#BAUD         ; timer1 used by RS232
         MOV TH1,#BAUD         ;
         MOV TCON,#0C1H        ; start timer1, INT0 edge trig
;
; IF smartbeacon enabled THEN check GPS data every 5 sec
;
Loop:    MOV SP,#SPstart       ;
         ACALL Retii           ;
         CLR EA                ;
         CLR GPSOK             ;
         CLR RMCOK             ;
         CLR AltOK             ;
         CLR GPSON             ; PWR on GPS
         MOV RMCCou,#10        ; try 10 times to get RMC data from GPS

         JNB FixPos,Norm       ;
         AJMP FixTX            ;
Norm:    MOV IE,#090H          ; enable interrupts from RS232
Ch_CD:
         MOV C,RXAF            ;
         MOV LEDgreen,C        ;
         JNB GPSOK,Ch_CD       ; check GPS data
         SETB LEDgreen         ; LED off

CAltOK:  JNB ShowAlt,ChSBec    ;
         JNB RMCOK,Nx5Sec      ; if no valid GPS data 5 more sec
         JB AltOK,ChSBec       ;
         SJMP CAltOK           ;
ChSBec:  JNB SMARTB,TX_Now     ;
         CLR EA                ;
         JNB CPeg,CheckSpeed   ; check CPeg
         MOV A,#ETurnT1        ; min beacon time at turn
         JB OPS1,SetTurn       ;
         MOV A,#ETurnT2        ;
SetTurn: ACALL SetEEP          ;
         ACALL ReEEP           ;
         XCH A,S5Count         ;
         CJNE A,S5Count,$+3    ;
         XCH A,S5Count         ;
         JC CheckSpeed         ;
TX_Now:  JMP TXNow             ;
Nx5_Sec: AJMP Nx5Sec           ;
CheckSpeed:
         JB WaitTime,Nx5_Sec   ;
         MOV A,#ESTim1         ;
         JB OPS1,SetFVel       ; jump if config 1
         MOV A,#ESTim2         ;
SetFVel: ACALL SetEEP          ; read fast speed data from EEP
         ACALL ReEEP           ;
         MOV R5,A              ; slow rate in R5
         ACALL ReEEP           ;
         MOV R2,A              ; high speed in R2
         ACALL ReEEP           ; read slow speed data from EEP
         MOV R3,A              ; slow speed in R3
         CJNE A,GSBin,$+3      ;
         JNC SlowSpeed         ; C=1 if A < GSbin (A=slowspeed limit)
         MOV A,GSBin           ;
         MOV B,R2              ;
         CJNE A,B,$+3          ;
         JNC TX_Now            ; GSbin > Fastspeed limit
         MOV A,R2              ; A= fastspeed
         CLR C                 ;
         SUBB A,GSbin          ; Fastspeed - GS
         MOV B,R5              ; B slow rate
         MUL AB                ;
         MOV R6,B              ; msb
         MOV R7,A              ; lsb
         MOV A,R2              ;
         CLR C                 ;
         SUBB A,R3             ; A = FastSpeed - SlowSpeed
         ACALL Div16           ;
C_Tcou:  INC A                 ;
         MOV B,A               ;
         MOV A,TCount          ;
         CJNE A,B,$+3          ;
         JNC TX_Now            ;
         JMP NoSmart           ; 
SlowSpeed:
         MOV A,R5              ;
         SJMP C_Tcou           ;
;
; division of R6 (msb) ,R7 (lsb) by A
;
Div16:   CPL A                 ; 2' compl
         ADD A,#1              ;
         XCH A,R6              ;
         MOV R5,#9             ; loop counter
Div1:    JNC Div2              ;
         ADD A,R6              ;
         SETB C                ;
         SJMP Div3             ;
Div2:    ADD A,R6              ;
         JC Div3               ;
         SUBB A,R6             ;
Div3:    XCH A,R7              ;
         RLC A                 ;
         XCH A,R7              ;
         RLC A                 ;
         DJNZ R5,Div1          ;
         RRC A                 ;
         XCH A,R7              ;
         RET                   ;     
SendPacket:                    ;
         CLR WaitTime          ;
;
; check for RX audio
;
WaitRX:  MOV R1,#0             ;
ChkRXAF: MOV C,RXAF            ; check comparator
         MOV LEDgreen,C        ;
         JNC WaitRX            ; jump if RXAF is active 
         DJNZ R1,ChkRXAF       ;
         SETB LEDgreen         ;
         MOV A,#ECalAn1        ; number of bytes in call text
         JB OPS1,SetCa1        ;
         MOV A,#ECalAn2        ;
SetCa1:  ACALL SetEEP          ;
         ACALL ReEEP           ;
         MOV CaAnt,A           ;
         JNB TXBeaC,AntOK      ;
         DEC CaAnt             ;
AntOK:   ACALL ReEEP           ;
         MOV BeAnt,A           ;
         ACALL GetSinV         ; get sinus table
         MOV CrcH,#0FFH        ; crc init (hi)
         MOV CrcL,#0FFH        ; crc init (lo)
         ACALL BeregnCrc       ; calc crc
         MOV A,#ETXDEL1        ;
         JB OPS1,SetTX1        ;
         MOV A,#ETXDEL2        ;
SetTX1:  ACALL SetEEP          ;
         ACALL ReEEP           ;
         MOV R3,A              ; TXdelay in R3
         MOV A,#ECaSD1         ;
         JB OPS1,SetE2         ;
         MOV A,#ECaSD2         ;
SetE2:   ACALL SetEEP          ;
         MOV A,#EEPROM+1       ; read EEPROM
         ACALL GoMast          ; ready to read EEPROM
         MOV TH0,#T1200        ; timer0 reload reg
         MOV TL0,#T1200        ; generate 1200 Hz
         MOV TH1,#0FDH         ;
         MOV TL1,#00           ; 
         MOV TMOD,#012H        ; 8 bit counter T0  16 bit counter 1
         MOV TCON,#050H        ; timer0,timer1 run
         MOV SCON,#0           ;
         MOV R0,#12            ; sinus 12 step
         MOV IE,#8AH           ; enable only interrupts from timer0 og timer1
         CLR LEDred            ; red LED TX active
         SETB TAST             ; tast sender
         SETB FO               ;
         JNB RMCOK,S_Flag      ;
         CLR LEDgreen          ; green LED navigation data OK
S_Flag:  ACALL SendFlag        ; tja
         DJNZ R3,S_Flag        ;
         MOV DPTR,#SoftVer     ;
         ACALL SendROM         ;
         MOV R5,CaAnt          ;
         ACALL SendByI2C       ;
         MOV R1,#BUF1          ;
NxR1:    MOV A,@R1             ;
         ACALL SendBy          ;
         INC R1                ;
         MOV A,R1              ;
         CJNE A,BytAdr,NxR1    ;
         JB TXBeaC,SendCrc     ;
         MOV R5,BeAnt          ; send comment
         ACALL SendByI2C       ;
         DEC B_Rate            ;
SendCrc: MOV A,CrcL            ;
         ACALL SendBy          ;
         MOV A,CrcH            ;
         ACALL SendBy          ;
         ACALL SendFlag        ;
         ACALL SendFlag        ;
         ACALL RcvByte         ; stop I2C
         CLR EA                ;
         CLR TR1               ;
         CLR TR0               ;
         CLR TAST              ;
         SETB LEDgreen         ;
         SETB LEDred           ;
         CLR TXBeaC            ;
         MOV P1,#0F7H          ; set pins on P1 high 
         MOV A,B_rate          ;
         JZ SendBeacon         ;
         RET                   ;
;
; send stations setup
;
SendBeacon:
         ACALL GetBeaRate      ;
         MOV A,#EBeaS1         ; start p statustext i EEprom
         JB OPS1,SetBea1       ;
         MOV A,#EBeaS2         ;
SetBea1: ACALL SetEEP          ;
         ACALL ReEEP           ; i A findes start adr p statustext
         ACALL SetEEP          ;
         MOV R1,#BUF1          ;
ReadSta: ACALL ReEEP           ;
         JZ StatEnd            ;
         MOV @R1,A             ;
         INC R1                ;
         SJMP ReadSta          ;
StatEnd: MOV BytAdr,R1         ; antal bytes i RAM der skal sendes
         MOV R0,#5             ;
StatDel: CALL MaxDel           ; delay inden status text sendes
         DJNZ R0,StatDel       ;
         SETB TXBeaC           ;
         AJMP SendPacket       ;
;
SendFlag:                      ; flag = 7E
         CPL FO                ; bit = 0 skift frq
         MOV R2,#7             ; 7 gennemlb frste bit = 0
NxFlBit: CLR TBaud             ;
         JNB TBaud,$           ; vent til bit er sendt
         DJNZ R2,NxFlBit       ; hop til nste flagbit
         CPL FO                ; bit = 0 skift frq
         CLR TBaud             ;
         JNB TBaud,$           ;
         MOV CoOne,#5          ;
         RET                   ;

SendROM: CLR A                 ;
         MOVC A,@A+DPTR        ;
         JZ RomOK              ;
         ACALL SendBy          ;
         INC DPTR              ;
         SJMP SendROM          ;
RomOK:   RET                   ;
;
; sender byte der findes i A
;
SendBy:  MOV R2,#8             ; send 8 bits
SendNx:  CLR C                 ;
         RRC A                 ;
         JNC BitL              ;
         CLR TBaud             ;
         JNB TBaud,$           ; samme frq = send 1
         DJNZ CoOne,BitOK      ;
BitL:    CPL FO                ; skift frq = send 0
         CLR TBaud             ;
         JNB TBaud,$           ;
         MOV CoOne,#5          ; reset tller for bit=1
BitOK:   DJNZ R2,SendNx        ;
         RET                   ;
;
; start p pgm del der lser bit via I2C og sender dette
;
SendByI2C:
         MOV R2,#8             ; 8 bits
TXLoop:  SETB SCL              ; 1 SCL hj
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 vent p SCL gr hj
         NOP                   ; 1
         MOV C,SDA             ; 1
         JNC SDA_L             ; 2
         CLR TBaud             ; 1
         CLR SCL               ; 1
         JNB TBaud,$           ; 2 samme frq = send 1
         DJNZ CoOne,Bit_OK     ; 2
SDA_L:   CPL FO                ; 1 skift frq = send 0
         CLR TBaud             ; 1
         CLR SCL               ; 1
         JNB TBaud,$           ; 2
         MOV CoOne,#5          ; 2 reset tller for bit=1
Bit_OK:  DJNZ R2,TXLoop        ; 2
         CLR SDA               ; 1 send ACK
         SETB SCL              ; 1 SCL hj
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 vent p SCL gr hj
         CLR SCL               ; 1
         SETB SDA              ; 1
         DJNZ R5,SendByI2C     ; 2
         RET                   ; 2
;
; conversion  m to feet
;
Conv_m_f:
         CLR A                 ; 
         MOV BCDBUF1,A         ; reset BCD buffer
         MOV BCDBUF2,A         ; reset BCD buffer
         MOV R1,#BCDBUF2+1     ;
; check om fortegn er minus
;         CLR AltMinus          ;
         MOV A,T_BUF+1         ;
         CJNE A,#'-',NoMinus   ;
         RET                   ; ret hvis negativ altitude
;         MOV T_BUF+1,#'0'      ;
;         SETB AltMinus         ;
NoMinus: DEC R1                ;
         MOV B,@R0             ; sidste karakter i altitude
         DEC R0                ;
         MOV A,@R0             ;
         DEC R0                ;
         DJNZ R2,ReadNx        ;
         MOV A,#0              ;
         MOV R2,#1             ;
ReadNx:  ACALL ASC2BCD         ;
         MOV @R1,A             ;
         DJNZ R2,NoMinus       ;
;
; data er konverteret fra ASCII til BCD start beregning
; konvertering af alt fra m til feet
; feet = 3*m +3*m/10   ( = ca. 3.3*m)
; beregning feet = m+m+m + (m+m+m)/10
; m er max 16 bits dvs max alt 9999 m
;
         MOV A,BCDBUF2         ;
         ADD A,BCDBUF2         ;
         DA A                  ;
         MOV T_BUF,A           ; gem A (lsb)
         MOV A,BCDBUF1         ;
         ADDC A,BCDBUF1        ;
         DA A                  ;
         MOV T_BUF+1,A         ;
         CLR A                 ;
         ADDC A,#0             ;
         DA A                  ;
         MOV T_BUF+2,A         ; gem A (msb)
         MOV A,T_BUF           ;
         ADD A,BCDBUF2         ;
         DA A                  ;
         MOV T_BUF,A           ; gem A (lsb)
         MOV A,T_BUF+1         ;
         ADDC A,BCDBUF1        ;
         DA A                  ;
         MOV T_BUF+1,A         ; gem A
         MOV A,T_BUF+2         ;
         ADDC A,#0             ;
         DA A                  ;
         MOV T_BUF+2,A         ; gem A (msb)
; T_BUF - T_BUF+2 indeholder nu alt(i m)*3
; denne skal div med 10 og adderes igen
;
         MOV ALTBUF,T_BUF      ; gem vrdierne
         MOV ALTBUF+1,T_BUF+1  ;
         MOV ALTBUF+2,T_BUF+2  ;

         MOV R4,#4             ; roter 4 bits til hjre
RotBy:   CLR C                 ;
         MOV A,ALTBUF+2        ;
         RRC A                 ;
         MOV ALTBUF+2,A        ; msb
         MOV A,ALTBUF+1        ;
         RRC A                 ;
         MOV ALTBUF+1,A        ; 
         MOV A,ALTBUF          ;
         RRC A                 ;
         MOV ALTBUF,A          ; 
         DJNZ R4,RotBy         ;
; adder M*3  med M*3/10
         MOV A,T_BUF           ;
         ADD A,ALTBUF          ;
         DA A                  ;
         MOV T_BUF,A           ; gem A (lsb)
         MOV A,T_BUF+1         ;
         ADDC A,ALTBUF+1       ;
         DA A                  ;
         MOV T_BUF+1,A         ; gem A
         MOV A,T_BUF+2         ;
         ADDC A,ALTBUF+2       ;
         DA A                  ;
         MOV T_BUF+2,A         ; gem A (msb)
; beregning frdig - resultat konverteres til ASCII 
;        T_BUF+2    alt i feet msb
;        T_BUF+1    alt i feet
;        T_BUF      alt i feet lsb
;
         MOV R1,#BUFALTE       ;
         MOV A,T_BUF           ;
         ACALL BCD2ASC         ;
         MOV A,T_BUF+1         ;
         ACALL BCD2ASC         ;
         MOV A,T_BUF+2         ;
         ACALL BCD2ASC         ;
;         JNB AltMinus,Alt_OK   ;
;         MOV BUFALT+2,#'-'     ;
alt_OK:  RET                   ;
;
; ASCII to BCD and BCD to ASCII
;
BCD2ASC: MOV B,A               ;
         ANL A,#00FH           ; lsb
         ORL A,#030H           ;
         MOV @R1,A             ;
         DEC R1                ;
         MOV A,B               ;
         SWAP A                ;
         ANL A,#00FH           ;
         ORL A,#030H           ; B lsb
         MOV @R1,A             ;
         DEC R1                ;
         RET                   ; 
;
ASC2BCD: ANL A,#00FH           ; A msb
         ANL B,#00FH           ; B lsb
         SWAP A                ;
         ORL A,B               ;
         RET                   ;
;
; ombyt bits i ACC
;
ReversA: MOV C,ACC.0           ;
         MOV B.7,C             ;
         MOV C,ACC.1           ;
         MOV B.6,C             ;
         MOV C,ACC.2           ;
         MOV B.5,C             ;
         MOV C,ACC.3           ;
         MOV B.4,C             ;
         MOV C,ACC.4           ;
         MOV B.3,C             ;
         MOV C,ACC.5           ;
         MOV B.2,C             ;
         MOV C,ACC.6           ;
         MOV B.1,C             ;
         MOV C,ACC.7           ;
         MOV B.0,C             ;
         MOV A,B               ;
         RET                   ;
;
BeregnCrc:
         MOV DPTR,#SoftVer     ; software version
CalcCRC: CLR A                 ;
         MOVC A,@A+DPTR        ;
         JZ EEP_Crc            ;
         ACALL CrcCalc         ;
         INC DPTR              ;
         SJMP CalcCRC          ;
EEP_Crc: MOV A,#ECaSD1         ;
         JB OPS1,SetE3         ;
         MOV A,#ECaSD2         ;
SetE3:   ACALL SetEEP          ; beregn crc af data i EEp
         MOV R5,CaAnt          ;
NxEChr:  ACALL ReEEP           ;
         ACALL ReversA         ;
         ACALL CrcCalc         ;
         DJNZ R5,NxEChr        ;
R1_Crc:  MOV R1,#BUF1          ; beregn crc af data i RAM
ReR1:    MOV A,@R1             ;
         ACALL CrcCalc         ;
         INC R1                ;
         MOV A,R1              ;
         CJNE A,BytAdr,ReR1    ;
         JB TXBeaC,StOnly      ; hop kun status text
         MOV R5,BeAnt          ;
Nx_EChr: ACALL ReEEP           ; beregn crc af data i EEp
         ACALL ReversA         ;
         ACALL CrcCalc         ;
         DJNZ R5,Nx_EChr       ;
StOnly:  XRL CrcH,#0FFH        ; tilsidst XOR CrcH med FF
         XRL CrcL,#0FFH        ; tilsidst XOR CrcL med FF
         RET                   ;
;
; beregning af checksum bitvis
; benytter A,R2,R3,CrcH,CrcL
;    init af CrcH/L
;
;        MOV CrcH,#0FFH       ;
;        MOV CrcL,#0FFH       ;
;    nr crc er beregnet XOR med FF
;        XRL CrcH,#0FFH       ;
;        XRL CrcL,#0FFH       ;
;
CrcCalc: MOV R2,#8             ; 8 bit i en byte
         MOV R3,A              ; data i ACC gemmes i R3
NxCrc:   CLR C                 ;
         MOV A,CrcH            ; shift crc (H og L) 1 bit til hjre
         RRC A                 ;
         MOV CrcH,A            ;
         MOV A,CrcL            ;
         RRC A                 ;
         MOV CrcL,A            ;
         MOV A,R3              ;
         JNB ACC.0,Bit0        ; XOR C(arry) med bit 0 i A
         CPL C                 ;
Bit0:    JNC NxtCrcBit         ;
         XRL CrcL,#008H        ;
         XRL CrcH,#084H        ;
NxtCrcBit:
         MOV A,R3              ;
         RR A                  ; rot A 1 bit right
         MOV R3,A              ; save A
         DJNZ R2,NxCrc         ;
         RET                   ;
;
; timer 1 interrupt - ved TX interrupt med 1/1200 
;
Tim1Int: JB WaitTime,TimeDel   ;
         MOV TH1,#0FDH         ; 2
         MOV TL1,#00           ; 2
         ACALL Retii           ; 2 tillad int. fra timer0
         SETB TBaud            ;
         JB FO,Gen1200         ; 2
         MOV TH0,#T2200        ; 2
         RETI                  ; 2
Gen1200: MOV TH0,#T1200        ; 2
         RETI                  ; 2

TimeDel: DJNZ T_lo,NxtPer      ;
         MOV A,T_hi            ;
         JZ TimeGone           ;
         DEC T_hi              ;
         MOV T_lo,#0FFH        ;
         JNB GPSPWR,NxtPer     ; Hop GPS ej Sleepmode
         MOV A,T_hi            ;
         JNZ NxtPer            ; A=0 betyder ca 12 sek tilbage inden
         CLR GPSON             ; udsendelse derfor PWR p GPS
NxtPer:  JNB SmartB,NxtTim     ;
         DJNZ SCount,NxtTim    ;
         INC S5Count           ; 5 sec counter
         CLR WaitSB            ;
NxtTim:  MOV TL1,#0EDH         ; timer 1 (47mS)
         MOV TH1,#053H         ;
         RETI                  ;
TimeGone:
         CLR TR1               ;
         CLR WaitTime          ;
         INC TCount            ;
         SETB LEDgreen         ;
         RETI                  ;
;
; RS232 interrupt from GPS/PC  with approx 250mS delay
;
ReadRS:  MOV R3,#0             ; 
ChR3:    MOV R4,#0             ; 
ChRI:    JB RI,ReadCh          ; 
         DJNZ R4,ChRI          ; 
         DJNZ R3,ChR3          ; 
         RET                   ; 
ReadCh:  MOV A,SBUF            ; 
         CLR RI                ; 
         RET                   ; 
;
NoRX:    CLR TI                ;
         RETI                  ; 
;
; Serial interrupt pgm
;
RSINT:   JNB RI,NoRX           ; jump if int from TI
         MOV A,SBUF            ;
         CLR RI                ;
         CJNE A,#'$',NoGPS     ;
         AJMP ReadGPS          ; jump read GPS data
;
; Testmode for read/write to EEP
; and TX with 1200HZ, 2200Hz or 1200/2200 Hz
;
NoGPS:   CJNE A,#'>',NoRX      ; jump back if not '>'
NxSgn:   MOV SBUF,#'>'         ;
         JNB TI,$              ;
         CLR TI                ;
NxRead:  ACALL ReadRS          ;
         CJNE A,#'0',Chk1      ; transmit 1200 Hz
         MOV DPTR,#TRans0      ;
         ACALL NxVer           ;
         ACALL GetSinV         ;
         MOV TH0,#T1200        ; timer0 reload reg
         MOV TL0,#T1200        ; to make 1200 Hz
         SJMP GenTone          ;
Chk1:    CJNE A,#'1',Chk2      ; transmit 2200 Hz
         MOV DPTR,#TRans1      ;
         ACALL NxVer           ;
         ACALL GetSinV         ;
         MOV TH0,#T2200        ; timer0 reload reg
         MOV TL0,#T2200        ; to make 2200 Hz
GenTone: CLR RI                ;
         CLR LEDred            ; red LED on (TX)
         CLR EA                ;
         ACALL Retii           ;
         MOV TMOD,#022H        ;
         SETB TR0              ;
         MOV IE,#082H          ; only int from timer0
         JNB RI,$              ;
         CLR TR0               ;
         MOV TMOD,#021H        ;
         CLR TAST              ;
         SETB LEDred           ; red LED off
         MOV P1,#0F7H          ; set pins on P1 high
RSRET:   JNB FixPos,L_oop      ;
         AJMP FStart           ;
L_oop:   AJMP Loop             ;
Chk2:    CJNE A,#'2',Chk3      ; transmit 1200/2200 Hz
         MOV DPTR,#TRans2      ;
         ACALL NxVer           ;
         ACALL GetSinV         ;
         CLR LEDred            ; red LED on (TX)
                               ; set timer0 og timer1 op
         MOV TH0,#T1200        ; timer0 reload reg
         MOV TL0,#T1200        ; to make 1200 Hz
         MOV TH1,#0FDH         ;
         MOV TL1,#00           ; 
         MOV TMOD,#012H        ; 8 bit counter T0  16 bit counter 1
         MOV TCON,#050H        ; timer0,timer1 run
         MOV SCON,#0           ;
         CLR EA                ;
         ACALL Retii           ;
         MOV R0,#12            ; sinus 12 step
         MOV IE,#8AH           ; only interrupts from timer0 and timer1
         SETB TAST             ; PTT
         SETB FO               ;
GenNxt:  CLR TBaud             ;
ChkTB:   JB TBAud,NxTone       ;
         JB RXD,ChkTB          ;
         CLR EA                ;
         CLR TR0               ;
         CLR TR1               ;
         CLR TAST              ;
         SETB LEDred           ; red LED off
         MOV P1,#0F7H          ; set pins on P1 high 
         MOV TMOD,#021H        ; timer mode T0 16 bit counter
                               ; T1 8 bit reload ( RS232 )
         MOV PCON,#080H        ;
         MOV SCON,#050H        ;
         MOV TL1,#BAUD         ; timer1 used by RS232
         MOV TH1,#BAUD         ;
         MOV TCON,#0C1H        ; start timer1, INT0 edge trig
         AJMP RSRET            ;
NxTone:  CPL FO                ;
         SJMP GenNxt           ;
Chk3:    CJNE A,#'3',ChkR      ; test RX audio
         MOV DPTR,#TRans3      ;
         ACALL NxVer           ;
         CLR EA                ;
         ACALL Retii           ;
         CLR RI                ;
         MOV R1,#3             ;
         CLR LEDgreen          ; flash LED green twice
FlGreen: CALL MaxDel           ;
         CALL MaxDel           ;
         CALL MaxDel           ;
         CPL LEDgreen          ;
         DJNZ R1,FlGreen       ;
; now check comparator
AFTest:  MOV C,RXAF            ;
         MOV LEDgreen,C        ;
         JNB RI,AFTest         ;
         SETB LEDgreen         ;
         AJMP RSRET            ;
ChkR:    CJNE A,#'R',ChkV      ; read EEP
         JMP ReadEEP           ;
ChkV:    CJNE A,#'V',ChkW      ; read version
         ACALL VerTxtOut       ;
TryNx:   AJMP NoRx             ;
ChkW:    CJNE A,#'W',TryNx     ; write to EEP
         JMP WriteEEP          ;

;
; Read navigation data fra GPS
;
ChkAlt:  JNB ShowALT,WaitEnd   ;
         JNB RMCOK,WaitEnd     ;
         CJNE A,#'G',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'G',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'A',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         MOV R1,#BUFALT        ;
         MOV DPTR,#StartAlt    ;
         ACALL ReNeEP          ;
         MOV BytAdr,R1         ; gem sidste adr p data
         MOV R2,#5             ;
W_Komma: ACALL WaitKomma       ; vent p frste komma
         DJNZ R2,W_Komma       ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'0',Validsig  ; = 0 invalid signal
;         SJMP WaitEnd          ;
         SJMP AltFin           ;
Validsig:
         ACALL WaitKomma       ;
         ACALL WaitKomma       ;
         ACALL WaitKomma       ;
         MOV R0,#T_BUF         ; data gemmes herfra +1
         MOV R2,#0             ; antal karakterer inden '.' i R2
         ACALL ReadGS          ;

; alt er i m skal konverteres til feet
         ACALL Conv_m_f        ;
AltFin:  SETB AltOK            ;
WaitEnd: ACALL ReadRS          ;
         CJNE A,#LF,WaitEnd    ; vent p slut af data = (CR)+LF
         RETI                  ;
;
ReadGPS: ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'G',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'P',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'R',ChkAlt    ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'M',WaitEnd   ;
         ACALL ReadRS          ; vent p nste karakter
         CJNE A,#'C',WaitEnd   ;
         ACALL WaitKomma       ; vent p frste komma
         ACALL WaitKomma       ; vent p nste komma
         ACALL ReadRS          ; ls p nste karakter
         CJNE A,#'V',C_Valid   ;
; vent max 10 sek for GPS til at blive valid
; til dette bruges
         DJNZ RMCCou,WaitVal   ; 10 gennemlb for at
;         JB GPSPWR,WaitVal     ; vent til signal fra GPS er valid
                               ; men hvorlnge ???  feks 20 sek ?
         ACALL ReadNoVal       ; ls NoValid data
         SETB GPSOK            ; data fra GPS men ej valid

WaitVal: AJMP WaitEnd          ;
C_Valid: CJNE A,#'A',WaitEnd   ; A= valid gpsdata
         ACALL WaitKomma       ; vent p nste komma
         MOV R1,#BUF1          ; gem nav data i buffer
         MOV R2,#7             ;
         ACALL GetGPS          ; get latt ( eg 5545.10)
         ACALL WaitKomma       ;
         MOV R2,#1             ; 1 byte = N/S
         ACALL GetGPS          ;
         ACALL SetSYMTAB       ;
         ACALL WaitKomma       ;
         ACALL ReEEP           ;
         MOV @R1,A             ; symbol tabel
         INC R1                ; plads til tegn
         MOV R2,#8             ;
         ACALL GetGPS          ; get long
         ACALL WaitKomma       ;
         MOV R2,#1             ; 1 byte = E/W
         ACALL GetGPS          ;
         ACALL SetSYMID        ;
         ACALL WaitKomma       ;
         ACALL ReEEP           ;
         MOV @R1,A             ; symbol ID
         INC R1                ; 
         MOV R3,#2             ; skriv 000/000 for TH og GS
WrR2:    MOV R2,#3             ; indtil korrekte vrdier er
WrTHZ:   MOV @R1,#'0'          ; indlst
         INC R1                ;
         DJNZ R2,WrTHZ         ;
         MOV @R1,#'/'          ;
         INC R1                ;
         DJNZ R3,WrR2          ;
         MOV BytAdr,R1         ;
;
; GS (groundspeed data) lses frst
         MOV R2,#0             ; antal karakterer lst indtil ',' eller '.'
         MOV R0,#T_BUF         ;
         ACALL ReadGS          ; hent GS data
; data for GS er lst. Antal karakterer fr ',' findes i R2
; flyt data til datastreng
         MOV R1,#BUF_GS        ; R1 peger nu p sidste plads for GS
         CJNE R2,#0,WrGS       ; hvis R2 = 0 da sttes data = 000
         SJMP ReadTH           ;
WrGS:    MOV A,@R0             ;
         MOV @R1,A             ;
         DEC R0                ;
         DEC R1                ;
         DJNZ R2,WrGS          ;
ConvGS:  JNB SMARTB,ReadTH     ; jump if no smartbeacon
         MOV A,BUF_GS          ; lsb
         ANL A,#00FH           ;
         MOV R2,A              ; 
         MOV A,BUF_GS-1        ;
         ANL A,#00FH           ;
         MOV R3,A              ; 
         MOV A,BUF_GS-2        ; msb
         ANL A,#00FH           ;
         MOV R4,A              ; GS msb in R4 and lsb in R2
; convert to Binary
; R2*1
; R3*10
; R4 *100
;
         MOV B,#100            ;
         MUL AB                ;
         MOV R4,A              ; save result
; if B > 0 then set GSBin to max speed
         MOV B,A               ;
         JNZ GSMax             ;
         MOV B,#10             ;
         MOV A,R3              ;
         MUL AB                ;
         MOV R3,A              ;
         ADD A,R2              ; R3*10+R2
         CLR C                 ;
         ADD A,R4              ;
         JNC GS_OK             ; A < 255 km/h
GSMax:   MOV A,#0FFH           ; A = 255 km/h
GS_OK:   MOV GSBin,A           ; save GS as binary
; TH (True Heading) lses
ReadTH:  MOV R2,#0             ; antal karakterer lst indtil ',' eller '.'
         MOV R0,#T_BUF         ;
         ACALL ReadGS          ; hent TT data
         MOV R1,#BUF_TH        ; R1 peger nu p sidste plads for TH
         CJNE R2,#0,WrTH       ; hvis R2 = 0 da sttes data = 000
         SJMP ConvTH           ;
WrTH:    MOV A,@R0             ;
         MOV @R1,A             ;
         DEC R0                ;
         DEC R1                ;
         DJNZ R2,WrTH          ;
ConvTH:  JNB SMARTB,NoTH       ; jump if no smartbeacon
         MOV A,#1              ;
         CJNE A,GSBin,$+3      ; if GSBin < 1 then dont check turn angle
         JNC NoTH              ;
         MOV A,BUF_TH          ; lsb
         ANL A,#00FH           ;
         CLR C                 ;
         RRC A                 ;
         ADDC A,#0             ;
         MOV R2,A              ;
         MOV A,BUF_TH-1        ;
         ANL A,#00FH           ;
         MOV R3,A              ; 
         MOV A,BUF_TH-2        ; msb
         ANL A,#00FH           ;
         MOV R4,A              ; GS msb in R4 and lsb in R2
; convert TH/2 to Binary   (range TH 0-359 and TH/2 0-180)
; R2/2
; R3*5
; R4*50
;
         MOV B,#50             ;
         MUL AB                ;
         MOV R4,A              ; save result
         MOV B,#5              ;
         MOV A,R3              ;
         MUL AB                ;
         MOV R3,A              ;
         ADD A,R2              ; R3*5+R2
         CLR C                 ;
         ADD A,R4              ;
         MOV R4,A              ; Save TH/2
; A = TH/2 in binary
; Find turn angle /2
         MOV B,THBin           ;
         CJNE A,B,$+3          ; if A < THBin  C(arry) = 1
         JNC NoCh              ;
;  THBin > A
         XCH A,B               ;
NoCh:    CLR C                 ;
         SUBB A,B              ;
; turn angle in A
         MOV TurnA,A           ;
         MOV THBin,R4          ; save new heading/2
; calc turnthreshold
         MOV A,#ETurnA1        ;
         JB OPS1,Turn1         ;
         MOV A,#ETurnA2        ;
Turn1:   ACALL SetEEP          ;
         ACALL ReEEP           ;
         MOV R2,A              ; Turn angle in R2
         ACALL ReEEP           ;
         MOV R3,A              ; Turnslope in R3
         MOV B,GSbin           ; get aktual speed
         DIV AB                ;
         CLR C                 ;
         ADDC A,R2             ;
         JNC CheckTurn         ;
         MOV A,#0FFH           ; max vrdi til A
CheckTurn:
         CJNE A,TurnA,$+3      ;
         MOV CPeg,C            ;
NoTH:    SETB GPSOK            ;
         SETB RMCOK            ; nav data OK
         AJMP WaitEnd          ;
;
; ls x antal bytes og gem disse p adr i R1
; antal bytes i R2
;
GetGPS:  ACALL ReadRS          ; vent p nste karakter
         MOV @R1,A             ;
         INC R1                ;
         DJNZ R2,GetGPS        ;
         RET                   ;
;
WaitKomma:                     ;
         MOV Creg,#','         ; vent p ,
; vent p karakter (findes i Creg )
;
WaitCh:  ACALL ReadRS          ;
         CJNE A,Creg,WaitCh    ;
         RET                   ;
;
ReadGS:  ACALL ReadRS          ;
         CJNE A,#',',GSData    ;
         RET                   ; 
GSData:  CJNE A,#'.',ReadDa    ; karakter = '.' vent p ','
         AJMP WaitKomma        ; retur efter modtaget ','
ReadDa:  INC R0                ;
         MOV @R0,A             ;
         INC R2                ; tller for antal karakterer fr '.'
         SJMP ReadGS           ;
;

ReadNoVal:
         MOV DPTR,#NoValidGPS  ;
         MOV R1,#BUF1          ;
ReNeEP:  CLR A                 ;
         MOVC A,@A+DPTR        ;
         JZ NoEData            ;
         MOV @R1,A             ;
         INC R1                ;
         INC DPTR              ;
         SJMP ReNeEP           ;
NoEData: MOV BytAdr,R1         ;
         RET                   ;

GetBeaRate:                    ; beacon rate
         MOV A,#EBrate1        ;
         JB OPS1,SetBea        ;
         MOV A,#EBrate2        ;
SetBea:  ACALL SetEEP          ;
         ACALL ReEEP           ;
         MOV B_rate,A          ;
         RET                   ;
;
GetFixD: MOV A,#EFixPos        ;
         ACALL SetEEP          ;
         MOV R1,#BUF1          ;
         MOV R2,#18            ; read latt/long position
ReNxLL:  ACALL ReEEP           ;
         MOV @R1,A             ;
         INC R1                ;
         DJNZ R2,ReNxLL        ;
         ACALL SetSYMTAB       ;
         ACALL ReEEP           ;
         MOV BUF1+8,A          ; symtab
         ACALL SetSYMID        ;
         ACALL ReEEP           ;
         MOV @R1,A             ; symbol ID
         INC R1                ; 
         MOV BytAdr,R1         ;
         RET                   ;

SetSYMTAB:
         MOV A,#ESYMTAB1       ;
         JB OPS1,S_SY2         ;
         MOV A,#ESYMTAB2       ;
S_SY2:   AJMP SetEEP           ;

SetSYMID:
         MOV A,#ESYMID1        ;
         JB OPS1,S_SY1         ;
         MOV A,#ESYMID2        ;
S_SY1:   AJMP SetEEP           ;


;
VerTxtOut:                     ;
         MOV DPTR,#VerTxt      ;
NxVer:   CLR A                 ;
         MOVC A,@A+DPTR        ;
         JZ Notxt              ;
         MOV SBUF,A            ;
         JNB TI,$              ;
         CLR TI                ;
         INC DPTR              ;
         SJMP NxVer            ;
Notxt:   RET                   ;
;
; table with sinus values stored in internal RAM (adr 00-0B) to
; be able to read the values fast
;
GetSinV: MOV DPTR,#Sinus12     ; set up for read sinustable
         MOV R0,#0             ; values are stored from addr 00 - 0B
ReNxSi:  CLR A                 ; 
         MOVC A,@A+DPTR        ; 12 values
         MOV @R0,A             ;
         INC DPTR              ;
         INC R0                ;
         CJNE R0,#12,ReNxSi    ;
         RET                   ;
;
;  I2C software part
;
SStop:   CLR SDA               ;
         SETB SCL              ; 1 SCL high
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 wait for SCL to go high
         SETB SDA              ;
         RET                   ;
;
ReEEP:   MOV A,#EEPROM+1       ; read from EEPROM
         ACALL GoMast          ;
         JB NoAck,RDEX         ;
RcvByte: MOV R4,#8             ; rcv 8 bits
RXLoop:  SETB SCL              ; 1 SCL high
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 wait until SCL goes high
         NOP                   ;
         MOV C,SDA             ;
         RLC A                 ;
         CLR SCL               ;
         NOP                   ;
         DJNZ R4,RXLoop        ;
         SETB SDA              ; send NAK
         SETB SCL              ; 1 SCL high
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 wait until SCL goes high
         NOP                   ;
         CLR SCL               ;
         SETB SDA              ;
RDEX:    AJMP SStop            ; send stop
;
InitEEP: CLR A                 ;
SetEEP:  MOV Creg,A            ; I2C adr in Acc
         MOV A,#EEPROM         ; write EEPROM
         ACALL GoMast          ;
         JB NoACK,SDEX         ; check slave answer
         MOV A,Creg            ; I2C adr
         ACALL SendIIC         ;
SDEX:    AJMP SStop            ; send stop
;
GoMast:  CLR NoACK             ;
         JNB SCL I2CErr        ; SCL must be high
         JNB SDA I2CErr        ; SDA must be high
         CLR SDA               ; I2C start
         NOP                   ;
         CLR SCL               ;
SendIIC: MOV R4,#8             ; 8 bits
SNxt:    RLC A                 ;
         MOV SDA,C             ;
         SETB SCL              ; 1 SCL high
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 wait until SCL is high
         CLR SCL               ;
         DJNZ R4,SNxt          ;
         SETB SDA              ;
         SETB SCL              ; 1 SCL high
         NOP                   ; 1
         NOP                   ; 1
         JNB SCL,$             ; 2 wait until SCL is high
         JNB SDA,AckOK         ;
         SETB NoAck            ;
AckOK:   CLR SCL               ;
         JB NoAck,AckERR       ;
         RET                   ;
;
I2CErr:
;        SETB BusErr           ;
         SETB NoAck            ;
         MOV DPTR,#I2CERROR    ;
         JMP NxVer             ;
AckERR:  MOV DPTR,#ACKERROR    ;
         JMP NxVer             ;
;
; 10 mS delay
;
Dly10mS: MOV R4,#20            ; delay approx 10 mS after writing EEP
DelR4:   CLR A                 ; setup for 10mS delay
DelACC:  DEC A                 ;
         JNZ DelACC            ;
         DJNZ R4,DelR4         ;
         RET                   ;
MaxDel:  MOV R4,#0             ;
         SJMP DelR4            ;
;
ReadEEP: CALL InitEEP          ;
         MOV R0,#0             ;
NxEEp:   CALL ReEEP            ;
         MOV SBUF,A            ;
         JNB TI,$              ;
         CLR TI                ;
         DJNZ R0,NxEEp         ;
         JMP NoRx              ;
;
WriteEEP:
         MOV R0,#BUF1          ;
Wait_Ch: CALL ReadRS           ; ** get next byte
         MOV @R0,A             ;
         INC R0                ;
         CJNE R0,#BUF1+9,Wait_Ch;
         MOV R0,#BUF2          ;
NxEEPB:  MOV A,#EEPROM         ; write to EEPROM
         CALL GoMast           ;
         JB NoACK,WriteEEP     ; ???
         MOV A,BUF1            ; I2C adr
         CALL SendIIC          ;
         MOV A,@R0             ;
         CALL SendIIC          ;
         CALL Sstop            ;
         CALL Dly10ms          ;
         INC R0                ;
         INC BUF1              ;
         CJNE R0,#BUF1+9,NxEEPB;
         JMP NxSgn             ;
;
; **** End of I2C part ****
;
;
; table for sinusvalues uses port 1 (P1.4 - P1.7) other portpins
;  = 1 (P1.0 - P1.3) voltage swing 1 - 5V
;
Sinus12: DB 09FH,0CFH,0EFH,0FFH,0EFH,0CFH
         DB 09FH,06FH,04FH,03FH,04FH,06FH

TRans0:  DB 'Transmitting 1200 Hz',CR,LF,0
TRans1:  DB 'Transmitting 2200 Hz',CR,LF,0
TRans2:  DB 'Transmitting 1200 / 2200 Hz',CR,LF,0
TRans3:  DB 'Checking RX audiolevel',CR,LF,0

I2CERROR:
         DB 'I2C error',CR,LF,0
ACKERROR:
         DB 'No ACK from slave',CR,LF,0
;
NoValidGPS:
         DB '0000.00N\0000.00W./',0
StartAlt:
         DB 'A=000000/',0
;
SoftVer: DB 'A'*2,'P'*2,'Z'*2,'1'*2,'0'*2,'0'*2,'0'*2,0
VerTXT:  DB 'OZ4HZ  APRS Tracker with 80S4051 ver 1.1 06 03 17',CR,LF,0

         END